//===================================================================
// aISA-S94 user application interface
//-------------------------------------------------------------------
// Copyright (c) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================

#ifndef __INC_AISA94_H__
#define __INC_AISA94_H__

#ifdef __cplusplus
extern "C" {
#endif

//-------------------------------------------------------------------
// \[X\
//-------------------------------------------------------------------
#define AISA94_MAX_MEM				9
#define AISA94_MAX_IO					20
#define AISA94_MAX_IRQ				7
#define AISA94_MAX_DMA				7

typedef struct {
	DWORD	dwNumMemWindows;							// Not used
	DWORD	dwMemBase		[AISA94_MAX_MEM];			// Not used
	DWORD	dwMemLength		[AISA94_MAX_MEM];			// Not used
	DWORD	dwMemAttrib		[AISA94_MAX_MEM];			// Not used
	DWORD	dwNumIOPorts;								// Num IO ports
	DWORD	dwIOPortBase	[AISA94_MAX_IO];			// I/O port base
	DWORD	dwIOPortLength	[AISA94_MAX_IO];			// I/O port length
	DWORD	dwNumIRQs;									// Not used
	DWORD	dwIRQRegisters	[AISA94_MAX_IRQ];			// Not used
	DWORD	dwIRQAttrib		[AISA94_MAX_IRQ];			// Not used
	DWORD	dwNumDMAs;									// Not used
	DWORD	dwDMALst		[AISA94_MAX_DMA];			// Not used
	DWORD	dwDMAAttrib		[AISA94_MAX_DMA];			// Not used
	DWORD	dwReserved1		[3];						// Not used
} AISA94RESOURCE, *PAISA94R;

//-------------------------------------------------------------------
// G[R[h
//-------------------------------------------------------------------
#define AISA94_SUCCESS				0  // ُȂiIj
#define AISA94_ERR_SYSTEM				1  // VXeG[
#define AISA94_ERR_NO_DEVICE			2  // gp\ȃfoCX܂
#define AISA94_ERR_IN_USE				3  // w̃foCX͎gpł
#define AISA94_ERR_INVALID_SLOT		4  // Ș_Xbgł
#define AISA94_ERR_RESOURCE			5  // \[XG[
#define AISA94_ERR_INVALID_PORT		6  // sȃ|[gv
#define AISA94_ERR_INVALID_ARG		7  // sȈv܂
#define AISA94_ERR_PORT				8  // ȃ|[gł
#define AISA94_ERR_INVALID_ADR		9  // ȃAhXł
#define AISA94_ERR_BUSY				10 // ^pł

//-------------------------------------------------------------------
// ̑̒`
//-------------------------------------------------------------------
#define AISA94_SLOT_AUTO				((WORD)~0U)
#define AISA94_MAX_SLOTS				16

//-------------------------------------------------------------------
// gkr}bv
//-------------------------------------------------------------------
#define AISA94_MEM_CMD				0x0000
#define AISA94_MEM_DO					0x0080
#define AISA94_MEM_DI					0x0100
#define AISA94_MEM_C1					0x0180
#define AISA94_MEM_C2					0x0200
#define AISA94_MEM_C3					0x0280
#define AISA94_MEM_C4					0x0300
#define AISA94_MEM_C5					0x0380
#define AISA94_MEM_C6					0x0400
#define AISA94_MEM_DATA				0x0480

//-------------------------------------------------------------------
// R}hR[h
//-------------------------------------------------------------------
#define AISA94_CMD_DI_READ			0
#define AISA94_CMD_COUNTER1_READ		1
#define AISA94_CMD_COUNTER2_READ		2
#define AISA94_CMD_COUNTER3_READ		3
#define AISA94_CMD_COUNTER4_READ		4
#define AISA94_CMD_COUNTER5_READ		5
#define AISA94_CMD_COUNTER6_READ		6
#define AISA94_CMD_DATA_REG_READ		7
#define AISA94_CMD_COUNTER1_CLEAR		9
#define AISA94_CMD_COUNTER2_CLEAR		10
#define AISA94_CMD_COUNTER3_CLEAR		11
#define AISA94_CMD_COUNTER4_CLEAR		12
#define AISA94_CMD_COUNTER5_CLEAR		13
#define AISA94_CMD_COUNTER6_CLEAR		14

BOOL	WINAPI Aisa94GetVersion(PDWORD pdwDllVersion, PDWORD pdwDrvVersion);
BOOL	WINAPI Aisa94Create(PWORD pwLogSlot);
BOOL	WINAPI Aisa94Close(WORD wLogSlot);
BOOL	WINAPI Aisa94GetResource(WORD wLogSlot, PAISA94R pres);
BOOL	WINAPI Aisa94Inpw(WORD wLogSlot, WORD wPort, PWORD pwData);
BOOL	WINAPI Aisa94Outpw(WORD wLogSlot, WORD wPort, WORD wData);
BOOL	WINAPI Aisa94MemRead(WORD wLogSlot, WORD wAdr, PWORD pwData);
BOOL	WINAPI Aisa94MemWrite(WORD wLogSlot, WORD wAdr, WORD wData);
BOOL	WINAPI Aisa94Initialize(WORD wLogSlot);
BOOL	WINAPI Aisa94Start(WORD wLogSlot, WORD wSNum);
BOOL	WINAPI Aisa94Stop(WORD wLogSlot);
BOOL	WINAPI Aisa94Dout(WORD wLogSlot, WORD wSNo, WORD wData);
BOOL	WINAPI Aisa94Din(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL	WINAPI Aisa94CntRead(WORD wLogSlot, WORD wSNo, WORD wCntNo, PWORD pwData);
BOOL	WINAPI Aisa94DRegRead(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL	WINAPI Aisa94CtrlWrite(WORD wLogSlot, WORD wSNo, WORD wCmd);
BOOL	WINAPI Aisa94CtrlRead(WORD wLogSlot, WORD wSNo, PWORD pwValue);
DWORD	WINAPI Aisa94GetLastError(WORD wLogSlot);

#ifdef __cplusplus
}
#endif

#endif // __INC_AISA94_H__
