/*****************************************************************************/
/*	aisa94w.c																 */
/*																			 */
/*	aISA-S94															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1999/05/26															 */
/*																			 */
/*****************************************************************************/

#define STRICT

#include <windows.h>
#include <tchar.h>

#include "aisa94w.h"	// aISA-S94

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa94wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

static FARPROC pAisa94GetVersion;
static FARPROC pAisa94Create;
static FARPROC pAisa94Close;
static FARPROC pAisa94GetResource;
static FARPROC pAisa94Inpw;
static FARPROC pAisa94Outpw;
static FARPROC pAisa94MemRead;
static FARPROC pAisa94MemWrite;
static FARPROC pAisa94Initialize;
static FARPROC pAisa94Start;
static FARPROC pAisa94Stop;
static FARPROC pAisa94Dout;
static FARPROC pAisa94Din;
static FARPROC pAisa94CntRead;
static FARPROC pAisa94DRegRead;
static FARPROC pAisa94CtrlWrite;
static FARPROC pAisa94CtrlRead;
static FARPROC pAisa94GetLastError;


/*****************************************************************************/
/* 	  aisa94.dll[h												 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA94_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa94wGetDllExportFunc() == FALSE)
	{
		Aisa94wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa94.dllA[h											 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-S94 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-S94̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wCreate(PWORD pwLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Create)(pwLogSlot);
}

/*****************************************************************************/
/* 	  aISA-S94̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot foCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wGetResource(WORD wLogSlot, PAISA94R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  [hŃ|[g璼ړ										 */
/* 	  wLogSlot foCX											 */
/*		  wPort	   |[gԍ												 */
/*		  pwData   ̓f[^i[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wInpw(WORD wLogSlot, WORD wPort, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Inpw)(wLogSlot, wPort, pwData);
}

/*****************************************************************************/
/* 	  [hŃ|[g֒ڏo											 */
/* 	  wLogSlot foCX											 */
/*		  wPort	   |[gԍ												 */
/*		  wData	   o̓f[^												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wOutpw(WORD wLogSlot, WORD wPort, WORD wData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Outpw)(wLogSlot, wPort, wData);
}

/*****************************************************************************/
/* 	  HLS ǂݍ												 */
/* 	  wLogSlot foCX											 */
/*		  wAdr	   AhX											 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wMemRead(WORD wLogSlot, WORD wAdr, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94MemRead)(wLogSlot, wAdr, pwData);
}

/*****************************************************************************/
/* 	  HLS 												 */
/* 	  wLogSlot foCX											 */
/*		  wAdr	   AhX											 */
/*		  wData	   ޒl												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wMemWrite(WORD wLogSlot, WORD wAdr, WORD wData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94MemWrite)(wLogSlot, wAdr, wData);
}

/*****************************************************************************/
/* 	  HLS 														 */
/* 	  wLogSlot	foCX										 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wInitialize(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Initialize)(wLogSlot);
}

/*****************************************************************************/
/* 	  HLS ʐMVXeJn												 */
/* 	  wLogSlot	foCX										 */
/*		  wSNum		^pTeCg									 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wStart(WORD wLogSlot, WORD wSNum)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Start)(wLogSlot, wSNum);
}

/*****************************************************************************/
/* 	  HLS ʐMVXe~												 */
/* 	  wLogSlot foCX											 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wStop(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Stop)(wLogSlot);
}

/*****************************************************************************/
/* 	  Do GÃAhXɏݎs									 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  wData	   ޒl												 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wDout(WORD wLogSlot, WORD wSNo, WORD wData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Dout)(wLogSlot, wSNo, wData);
}

/*****************************************************************************/
/* 	  Di GA̒lǂݍ											 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wDin(WORD wLogSlot, WORD wSNo, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94Din)(wLogSlot, wSNo, pwData);
}

/*****************************************************************************/
/* 	  JE^ n GA̒lǂݍ									 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  wCntNo   JE^ԍ(1`6)										 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wCntRead(WORD wLogSlot, WORD wSNo, WORD wCntNo, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94CntRead)(wLogSlot, wSNo, wCntNo, pwData);
}

/*****************************************************************************/
/* 	  f[^WX^GA̒lǂݍ								 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  pwData   ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wDRegRead(WORD wLogSlot, WORD wSNo, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94DRegRead)(wLogSlot, wSNo, pwData);
}

/*****************************************************************************/
/* 	  Rg[GAɃR}h							 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  wCmd	   R}h													 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wCtrlWrite(WORD wLogSlot, WORD wSNo, WORD wCmd)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94CtrlWrite)(wLogSlot, wSNo, wCmd);
}

/*****************************************************************************/
/* 	  Rg[GAǂݍ										 */
/* 	  wLogSlot foCX											 */
/*		  wSNo	   TeCgm											 */
/*		  pwValue  ǂݍݒli[̈ւ̃|C^						 */
/* ߂l TRUE															 */
/*		  FALSE	s														 */
/*****************************************************************************/
BOOL Aisa94wCtrlRead(WORD wLogSlot, WORD wSNo, PWORD pwValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa94CtrlRead)(wLogSlot, wSNo, pwValue);
}

/*****************************************************************************/
/* 	  aISA-S94̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa94wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA94_ERR_WRAPDLL;

	return (*pAisa94GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l TRUE															 */
/*		  FALSE s														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa94wGetDllExportFunc()
{
	// Aisa94GetVersion ̃AhX擾
	pAisa94GetVersion = GetProcAddress(hDLL, _T("Aisa94GetVersion"));
	if (pAisa94GetVersion == NULL)
		return FALSE;

	// Aisa94Create ̃AhX擾
	pAisa94Create = GetProcAddress(hDLL, _T("Aisa94Create"));
	if (pAisa94Create == NULL)
		return FALSE;

	// Aisa94Close ̃AhX擾
	pAisa94Close = GetProcAddress(hDLL, _T("Aisa94Close"));
	if (pAisa94Close == NULL)
		return FALSE;

	// Aisa94GetResource ̃AhX擾
	pAisa94GetResource = GetProcAddress(hDLL, _T("Aisa94GetResource"));
	if (pAisa94GetResource == NULL)
		return FALSE;

	// Aisa94Inpw ̃AhX擾
	pAisa94Inpw = GetProcAddress(hDLL, _T("Aisa94Inpw"));
	if (pAisa94Inpw == NULL)
		return FALSE;

	// Aisa94Outpw ̃AhX擾
	pAisa94Outpw = GetProcAddress(hDLL, _T("Aisa94Outpw"));
	if (pAisa94Outpw == NULL)
		return FALSE;

	// Aisa94MemRead ̃AhX擾
	pAisa94MemRead = GetProcAddress(hDLL, _T("Aisa94MemRead"));
	if (pAisa94MemRead == NULL)
		return FALSE;

	// Aisa94MemWrite ̃AhX擾
	pAisa94MemWrite = GetProcAddress(hDLL, _T("Aisa94MemWrite"));
	if (pAisa94MemWrite == NULL)
		return FALSE;

	// Aisa94Initialize ̃AhX擾
	pAisa94Initialize = GetProcAddress(hDLL, _T("Aisa94Initialize"));
	if (pAisa94Initialize == NULL)
		return FALSE;

	// Aisa94Start ̃AhX擾
	pAisa94Start = GetProcAddress(hDLL, _T("Aisa94Start"));
	if (pAisa94Start == NULL)
		return FALSE;

	// Aisa94Stop ̃AhX擾
	pAisa94Stop = GetProcAddress(hDLL, _T("Aisa94Stop"));
	if (pAisa94Stop == NULL)
		return FALSE;

	// Aisa94Dout ̃AhX擾
	pAisa94Dout = GetProcAddress(hDLL, _T("Aisa94Dout"));
	if (pAisa94Dout == NULL)
		return FALSE;

	// Aisa94Din ̃AhX擾
	pAisa94Din = GetProcAddress(hDLL, _T("Aisa94Din"));
	if (pAisa94Din == NULL)
		return FALSE;

	// Aisa94CntRead ̃AhX擾
	pAisa94CntRead = GetProcAddress(hDLL, _T("Aisa94CntRead"));
	if (pAisa94CntRead == NULL)
		return FALSE;

	// Aisa94DRegRead ̃AhX擾
	pAisa94DRegRead = GetProcAddress(hDLL, _T("Aisa94DRegRead"));
	if (pAisa94DRegRead == NULL)
		return FALSE;

	// Aisa94CtrlWrite ̃AhX擾
	pAisa94CtrlWrite = GetProcAddress(hDLL, _T("Aisa94CtrlWrite"));
	if (pAisa94CtrlWrite == NULL)
		return FALSE;

	// Aisa94CtrlRead ̃AhX擾
	pAisa94CtrlRead = GetProcAddress(hDLL, _T("Aisa94CtrlRead"));
	if (pAisa94CtrlRead == NULL)
		return FALSE;

	// Aisa94GetLastError ̃AhX擾
	pAisa94GetLastError = GetProcAddress(hDLL, _T("Aisa94GetLastError"));
	if (pAisa94GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
